#!/usr/bin/perl
#
# Programet per mantenir la galeria de postals d'In Extremis.
#     http://casal.upc.es/~in-extremis/Postals.html
#
# 10-Oct-2005 a 27-Gen-2006,  Daniel Clemente Laboreo
# n142857, arroba, gmail punt com    www.danielclemente.com
#  Llicncia: fes el que vulguis
#

# Necessita: config.txt al directori actual
# Crea: uns quants .html al directori actual:
#       - per a cada foto, _A.html, _F.html, _R.html
#       - Postals.html, .es.html, .en.html amb el llistat (cal moure'ls a ..)
#       

=xxxxxxxxxx   Format de config.txt xxxxxxxxx

# comentaris
#

[postal]
id: 26_Galles
ttol: Galles

on: A dalt d'una muntanya
qui: A, B i C
quan: 25 de novembre de 2005
qu: aix s un exemple!


[postal]
id: 24_Alcanyis
ttol: Alcanys

# etctera

=cut xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


use strict;
use warnings;

use Data::Dumper;



######### Llegir el llistat de postals  ###########

open CONFI, "<", "config.txt" or die "No puc obrir config.txt. Dins el codi s'explica com crear-lo.\n";

my @llista=();
my %actual=();

while (<CONFI>) {

	next if /^#/;
	next if /^\s*$/;	

	if (/^\[postal\]/) {
		push @llista,Data::Dumper->Dump([\%actual],["ractual"]) if %actual;
		%actual=();

	} elsif (/^\s*(.*?):\s*(.*)/) {
		$actual{$1}=$2;
	} else {
		warn "No entenc la lnia $. de config.txt\n";
	}


}

push @llista,Data::Dumper->Dump([\%actual],["ractual"]) if %actual;

close CONFI;

die "Tinc 0 postals! Crea el config.txt tal com est explicat dins el codi del programa\n" unless @llista;

# configuraci llegida. @llista s un array de "Dump"s de hashes



######### Crear html per a cada postal ###########

my $DIR_BASE="..";
# ruta al directori on es troba: Postals.html, Postals/ i Imatges/
# Quan es generen les postals s "..", per per a Postals.html ser "."


# Aix far falta per a Postals.html, quan diu "pots comenar veient la 1a"
my ($id_primera)= $llista[0]=~/'id' => '(.*)'/;

my $numpostals= scalar @llista;
my $i=1;
foreach (@llista) {

	my $ractual;
	eval $_;

	my %info=%{$ractual};
	
	my ($id,
	$jpg_anvers, $jpg_revers, $jpg_foto, $jpg_mini,
	$html_anvers, $html_revers, $html_foto,
	);

	$id=$info{'id'};

	print "Creant 3 .html per la postal nmero $i, que t id $id\n";

	# rutes i sufixos utilitzats
	$jpg_anvers  = 'Anversos/'.$id.'_pa.jpg';
	$jpg_revers  = 'Reversos/'.$id.'_pr.jpg';
	$jpg_foto    = 'Fotos/'.$id.'_fo.jpg';
	$jpg_mini    = 'Minis/'.$id.'_mi.jpg';
	$html_anvers = $id.'_A.html';
	$html_revers = $id.'_R.html';
	$html_foto   = $id.'_F.html';

	# enllaos a foto, anvers i revers
	my ($anar_a_foto,$anar_a_anvers,$anar_a_revers);

	if ( -e $jpg_foto ) {
		$anar_a_foto=q!<img src="Bot_Foto.jpg" alt="Veure foto" style="border:0;">!;
		$anar_a_foto=qq!<a href="$html_foto">$anar_a_foto</a>!;
	} else {
		$anar_a_foto=q!<img src="NoBot_Foto.jpg" alt="Foto no disponible" style="border:0;">!;
	}

	if ( -e $jpg_anvers ) {
		$anar_a_anvers=q!<img src="Bot_Anvers.jpg" alt="Veure anvers" style="border:0;">!;
		$anar_a_anvers=qq!<a href="$html_anvers">$anar_a_anvers</a>!;
	} else {
		$anar_a_anvers=q!<img src="NoBot_Anvers.jpg" alt="Anvers no disponible" style="border:0;">!;
	}

	if ( -e $jpg_revers ) {
		$anar_a_revers=q!<img src="Bot_Revers.jpg" alt="Veure revers" style="border:0;">!;
		$anar_a_revers=qq!<a href="$html_revers">$anar_a_revers</a>!;
	} else {
		$anar_a_revers=q!<img src="NoBot_Revers.jpg" alt="Revers no disponible" style="border:0;">!;
	}


	
	#Encara que no hi hagi imatge, es crea una pgina.
	# imatges per defecte a menys que existeixin les bones
	$jpg_anvers = "Sensepostal.jpg" unless -e $jpg_anvers;
	$jpg_revers = "Sensepostal.jpg" unless -e $jpg_revers;
	$jpg_foto   = "Sensepostal.jpg" unless -e $jpg_foto;
	$jpg_mini   = "Sensepostal.jpg" unless -e $jpg_mini;
	

	# valors buits per defecte
	
	$info{'on'}||='';
	$info{'qui'}||='';
	$info{'quan'}||='';
	$info{'qu'}||='';


	# URLs anterior i segent


	my ($anterior,$segUent);
	
	#      'id' => '24_Pedraforca',
	      
	# estem a posici $i-1 del array. L'ltima s $#llista
	if ($i-1-1 >= 0) {
		
		$llista[$i-1-1] =~ /'id' => '(.*)'/ ;
		
		#print "El dump de anterior vale: $llista[$i-1-1]\n\n";
		$anterior=
qq!<a href="$1_A.html"><img src="Anterior.gif" alt="Anterior" style="border:0;"></a>!;
	} else {
		$anterior = q!<img src="NoAnterior.gif" alt="" style="border:0;">!;
	}
	
	if ($i-1+1 <= $numpostals-1) {
		#print "El dump de siguiente vale: $llista[$i-1+1]\n\n";
		$llista[$i-1+1] =~ /'id' => '(.*)'/ ;
		
		$segUent=
qq!<a href="$1_A.html"><img src="Posterior.gif" alt="Segent" style="border:0;"></a>!;
	} else {
		$segUent = q!<img src="NoPosterior.gif" alt="" style="border:0;">!;
	}

	# crear les 3 pgines
	foreach ( [$html_anvers,$jpg_anvers],
	          [$html_revers,$jpg_revers],
		  [$html_foto,$jpg_foto],
		) {
		my $nom_fitxer=$_->[0];
		my $nom_imatge=$_->[1];
	
		# No cal crear pgines que no mostrin cap imatge
		# B, s que cal... Si no, s ms difcil
		#next if ! -e $nom_imatge;
		

my $info_imatge= <<"FINAL";

<div style="text-align:left;">
<br>
<ul>

 <li>
  <strong>On:</strong> $info{'on'}
 </li>
 
 <li>
  <strong>Qui:</strong> $info{'qui'}
 </li>
 
 <li>
  <strong>Quan:</strong> $info{'quan'}
 </li>
 
 <li>
  <strong>Qu:</strong> $info{'qu'}
 </li>
 
</ul>
</div>


<img src="$nom_imatge" alt="" style="border:2px solid;">

<br>
<br>
<table style="margin-left:auto; margin-right:auto;">

<tr>
<td>
$anar_a_foto
</td>
<td>
$anar_a_anvers
</td>
<td>
$anar_a_revers
</td>
</tr>

<tr>
<td>
<a href="../Postals.html"><img src="Album.gif" alt="Tornar" style="border:0;"></a>
</td>
<td>
$anterior
</td>
<td>
$segUent
</td>
</tr>

</table>


<p>Postal $i de $numpostals</p>

FINAL


open GRAVA, ">", $nom_fitxer;

print GRAVA 
codiPagina('ca', "lbum de postals: $info{'ttol'}", 
{ 'ca' => $nom_fitxer,
  'es' => '',
  'en' => ''
},
$info_imatge);

close GRAVA;


}
	$i++;

	
}


########### Crear Postals.html ##############

print "Creant Postals.html (i .es i .en). Els haurs de moure al directori pare\n";

# en ordre alfabtic
#      'ttol' => 'Pedraforca',
# Per cada parell ttol+dump, ordenar segons ttol i quedar-se amb el dump
@llista =
map { $_->[1] }
sort { $a->[0] cmp $b->[0]}
map { [ ($_=~ /'ttol' => '(.*)'/), $_] } @llista;


$DIR_BASE=".";
# perqu Postals.html est al directori arrel, ja no a Postals/

my $ct=''; # codi de la taula

$ct.=<<'FINAL';

      <center>
      <table style="height: 8px; text-align: center; margin-left: auto; margin-right: auto;" border="0" cellpadding="0" cellspacing="0">

        <tbody>
FINAL

while (@llista) {

$ct.=<<"FINAL";
          <tr>

            <td colspan="4" rowspan="1" style="width: 580px; height: 8px;"><img style="width: 590px; height: 8px;" alt="" src="$DIR_BASE/Imatges/Mecanitzat.jpg"></td>

          </tr>

          <tr>

FINAL



	for (1..4) {
	if(not @llista) {
$ct.=<<"FINAL";
            <td style="background-color: rgb(153, 102, 51); width: 145px; text-align: center; vertical-align: top;" align="undefined" valign="undefined"> <br>
            </td>
FINAL
		next;
	}

	my $f=shift @llista;
# <a href= $id_A.html > <img src= $id_mi.jpg > <br> $ttol

	my ($id, $html,$mini,$titol);

	($id) = $f=~/'id' => '(.*)'/;
	($titol)= $f=~/'ttol' => '(.*)'/;
	$titol =~ s/\\'/'/g; # Fa que les cometes funcionin

	$mini=$id.'_mi.jpg';
	$mini='Sensepostal_mi.jpg' unless -e "Minis/$mini";
	
	# Hi ha anvers, revers i foto?
	my ($hh_a,$hh_r,$hh_f) =
	( -e 'Anversos/'.$id.'_pa.jpg',
	  -e 'Reversos/'.$id.'_pr.jpg',
	  -e 'Fotos/'.$id.'_fo.jpg' );
	  

	# Noms posar enlla si hi ha una imatge interessant
	if ( !$hh_a and !$hh_r and !$hh_f ) {
	         # No posar enlla
	
$ct.=<<"FINAL";
            <td style="background-color: rgb(153, 102, 51); width: 145px; text-align: center; vertical-align: top;" align="undefined" valign="undefined"> <img style="border: 0px solid ;" alt="Miniatura." src="Postals/Minis/$mini" hspace="2"><br>

            <small>$titol</small> </td>

FINAL
	} else {

	# ordre de preferncia: anvers, foto, revers
	$html=$id.'_R.html' if $hh_r;
	$html=$id.'_F.html' if $hh_f;
	$html=$id.'_A.html' if $hh_a;

	
$ct.=<<"FINAL";
            <td style="background-color: rgb(153, 102, 51); width: 145px; text-align: center; vertical-align: top;" align="undefined" valign="undefined"> <a href="Postals/$html"><img style="border: 0px solid ;" alt="Miniatura." src="Postals/Minis/$mini" hspace="2"><br>

            <small>$titol</small></a> </td>

FINAL
	}



	} # fi for(1..4)

$ct.=<<"FINAL";
          </tr>

          <tr>

            <td colspan="4" rowspan="1" style="width: 590px; height: 8px;"><img style="width: 590px; height: 8px;" alt="" src="$DIR_BASE/Imatges/Mecanitzat.jpg"></td>

          </tr>

<tr><td><br></td></tr>

FINAL

}

$ct.=<<'FINAL';
        </tbody>
      </table>
      </center>
FINAL




open CA, ">", "Postals.html";
open ES, ">", "Postals.es.html";
open EN, ">", "Postals.en.html";

print CA codiPagina( 'ca', 'lbum de postals', 
{ 'ca' => 'Postals.html',
  'es' => 'Postals.es.html',
  'en' => 'Postals.en.html'
}, creaMarcPostals('ca',$ct ) );

print ES codiPagina( 'es', 'lbum de postales', 
{ 'ca' => 'Postals.html',
  'es' => 'Postals.es.html',
  'en' => 'Postals.en.html'
}, creaMarcPostals('es',$ct ) );

print EN codiPagina( 'en', 'Postcards album', 
{ 'ca' => 'Postals.html',
  'es' => 'Postals.es.html',
  'en' => 'Postals.en.html'
}, creaMarcPostals('en',$ct ) );

close CA;
close ES;
close EN;



exit;

# Aqu acaba el programa. Ara vnen funcions amb molt codi HTML














# codiPagina( idioma, subttol, altres_idiomes, principal )
# idioma: 'ca', 'es' o 'en'
# subttol: 'lbum de postals', etc.
# altres_idiomes: hash que relaciona 'ca','es','en' amb els HTML corresponents, o '' si no n'hi ha
# principal: tot el codi que hi ha dins del <td> de sota a la dreta
# 
sub codiPagina {

# parmetres
my $idioma=shift;
my $subtitol=shift;
my $altr_idi=shift;
#my $css=shift;
my $principal=shift;

# informacions derivades de l'idioma: ttol ("Associaci malabarista...") i men de l'esquerra
my ($titol,$menu);


if ($idioma eq 'ca') {
	$titol="Associaci malabarista In Extremis";
	$menu= << "FINAL";
      <table style="text-align: left; width: 175px;" border="0" cellpadding="0" cellspacing="3">

        <tbody>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blauroig.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Quisom.html">Qui
som</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blaneg.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Vinefes.html">Vine,
fes malabars</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_lilver.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Taller.html">Taller
malabarista</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_neggroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Enllacos.html">Enlla&ccedil;os</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_negbla.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Fotos.html">&Agrave;lbum
de fotos</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigblau.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);">&nbsp;<a href="$DIR_BASE/Postals.html"><span style="font-family: Arial; font-weight: bold;">&Agrave;lbum
de postals</span></a></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigbla.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/MoCiTu.html">Monocicloturisme</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigneg.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Maimu.html">Malabars
i muntanya</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blaugroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);">&nbsp;<a href="$DIR_BASE/Repte.html"><span style="font-family: Arial; font-weight: bold;">Repte dels
nombres</span></a></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_lilgroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Quedenou.html">Qu&egrave;
hi ha de nou</a></span></td>

          </tr>

        </tbody>
      </table>
      <br>
      
FINAL
	} elsif ($idioma eq 'es') {
	$titol="Asociacin malabarista In Extremis";
	$menu= <<"FINAL";

      <table style="text-align: left; width: 175px;" border="0" cellpadding="0" cellspacing="3">

        <tbody>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blauroig.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Quisom.es.html">Quienes
somos</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blaneg.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Vinefes.es.html">Ven, haz malabares</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_lilver.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Taller.es.html">Taller
malabarista</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_neggroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Enllacos.es.html">Enlaces</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_negbla.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Fotos.es.html">&Aacute;lbum
de fotos</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigblau.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);">&nbsp;<a style="color: rgb(153, 153, 153);" href="$DIR_BASE/Postals.html"><span style="font-family: Arial; font-weight: bold;">&Aacute;lbum
de postales</span></a></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigbla.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/MoCiTu.es.html">Monocicloturismo</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigneg.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Maimu.es.html">Malabares
y monta&ntilde;a</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blaugroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);">&nbsp;<a href="$DIR_BASE/Repte.es.html"><span style="font-family: Arial; font-weight: bold;">Reto de los
n&uacute;meros</span></a></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_lilgroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a style="color: rgb(153, 153, 153);" href="$DIR_BASE/Quedenou.html">Qu&eacute;
hay de nuevo</a></span></td>

          </tr>

        </tbody>
      </table>

      <br>
FINAL

	} elsif ($idioma eq 'en') {
	$titol="In Extremis juggling association";
	$menu= <<"FINAL";
      
      <table style="text-align: left; width: 175px;" border="0" cellpadding="0" cellspacing="3">
        <tbody>
          <tr>
            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blauroig.gif"></td>
            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Quisom.en.html">About us</a></span></td>
          </tr>

          <tr>
            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blaneg.gif"></td>
            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Vinefes.en.html">Come, juggle</a></span></td>

          </tr>
          <tr>
            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_lilver.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a style="color: rgb(153, 153, 153);" href="$DIR_BASE/Taller.html">Juggling
workshop</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_neggroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/Enllacos.en.html">Links</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_negbla.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Fotos.en.html">Photos
album</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigblau.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);">&nbsp;<a href="$DIR_BASE/Postals.en.html"><span style="font-family: Arial; font-weight: bold;">Postcards
album</span></a></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigbla.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;<a href="$DIR_BASE/MoCiTu.en.html">Turistic unicycling</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_roigneg.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a href="$DIR_BASE/Maimu.en.html">Juggling
and mountain</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="font-family: Impact; width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_blaugroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold; color: rgb(192, 192, 192);">&nbsp;<a style="color: rgb(153, 153, 153);" href="$DIR_BASE/Repte.html">Numbers
challenge</a></span></td>

          </tr>

          <tr>

            <td style="width: 21px;"><img style="width: 21px; height: 20px;" alt="" src="$DIR_BASE/Imatges/b_lilgroc.gif"></td>

            <td style="width: 154px; background-color: rgb(255, 177, 51);"><span style="font-family: Arial; font-weight: bold;">&nbsp;</span><span style="font-family: Arial; font-weight: bold;"><a style="color: rgb(153, 153, 153);" href="$DIR_BASE/Quedenou.html">What's
new</a></span></td>

          </tr>
        </tbody>
      </table>
      <br>

FINAL
	
	} else {
	die "Error intern, m'han passat un idioma invlid";
	}


	#if ($css) {$css=qq!<link rel="stylesheet" href="$css">!;} else {$css="";}

	my $codi_ai=""; # per a 'altres idiomes'

	my $sim='style="border:0"';

	if (my $desti=$altr_idi->{'ca'}) {
		$codi_ai.=
qq!<a href="$desti"><img src="$DIR_BASE/Imatges/ca.png" alt="" $sim></a>!;
	} else {
		$codi_ai.=qq!<img src="$DIR_BASE/Imatges/noca.png" alt="" $sim>!;
	}

	if (my $desti=$altr_idi->{'es'}) {
		$codi_ai.=
qq!<a href="$desti"><img src="$DIR_BASE/Imatges/es.png" alt="" $sim></a>!;
	} else {
		$codi_ai.=qq!<img src="$DIR_BASE/Imatges/noes.png" alt="" $sim>!;
	}

	if (my $desti=$altr_idi->{'en'}) {
		$codi_ai.=
qq!<a href="$desti"><img src="$DIR_BASE/Imatges/en.png" alt="" $sim></a>!;
	} else {
		$codi_ai.=qq!<img src="$DIR_BASE/Imatges/noen.png" alt="" $sim>!;
	}


	

	my $result= << "FINAL";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>

  <meta content="text/html; charset=ISO-8859-1" http-equiv="content-type">
  <title>In extremis. $subtitol.</title>

</head>


<body>

<table style="text-align: center; width: 800px;" border="0" cellpadding="0" cellspacing="0">

  <tbody>

    <tr>

      <td colspan="1" rowspan="2" style="width: 175px; height: 71px;"><a href="$DIR_BASE/Home.html"><img style="border: 0px solid ; width: 90px; height: 62px;" alt="Logo" src="$DIR_BASE/Imatges/mLogmovs.gif"></a></td>

      <td colspan="2" rowspan="1" style="width: 625px; height: 55px; background-color: rgb(255, 204, 102);">
      <h1><span style="font-family: Impact; color: rgb(102, 102, 102);">
$titol
      </span></h1>

      </td>

    </tr>

    <tr>

      <td style="width: 525px; height: 8px; background-color: rgb(255, 204, 102); text-align: left;">&nbsp;
&nbsp; &nbsp;<big><span style="font-family: Arial; font-weight: bold;">
$subtitol
</span></big></td>

      <td style="width: 100px; height: 8px; background-color: rgb(255, 204, 102); text-align: right; vertical-align: bottom;">
$codi_ai
</td>

    </tr>

    <tr>

      <td style="width: 175px; background-color: rgb(255, 204, 102); vertical-align: top;">
$menu
      </td>

      <td colspan="2" rowspan="1" style="width: 625px; vertical-align: top;">
$principal
      </td>

    </tr>

  </tbody>
</table>

<br>

</body>
</html>
FINAL

	return $result;
	
}





# creaMarcPostals( idioma, taula )
# idioma: 'ca', 'es', 'en'
# taula: codi HTML del 1 <table> amb les taula de miniatures
# Retorna tot el codi del MARC (no de tota la pgina, aix ho fa l'altra funci)
# 
sub creaMarcPostals {
	my $idioma=shift;
	my $taula=shift;

	# id_primera ho tenem calculat des del comenament
	my $html_primera="Postals/${id_primera}_A.html";

	my $comentari;
	if ($idioma eq 'ca') {
$comentari=<<'FINAL';
      <p style="margin-left: 40px;"><br>

&nbsp;&nbsp;&nbsp;
Aquest &eacute;s l'&agrave;lbum de postals de
l'associaci&oacute;.
Col&middot;leccionem postals de qualsevol lloc sempre que vagin
acompanyades
d'una foto del mateix lloc amb gent fent-hi malabarisme. Per
aix&ograve;,
al llarg dels anys els socis han anat enviant postals i fotos que ara
compartim
aqu&iacute;, a l'espai web. Si ens vols enviar una postal
acompanyada d'una
foto, ser&agrave; un plaer penjar-la en aquestes
p&agrave;gines. I a m&eacute;s
et convertir&agrave;s, si no ho ets encara, en soci de la
associaci&oacute;.
Per sempre. I gratis. </p>

      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Cal enviar les postals a la seg&uuml;ent adre&ccedil;a: </p>

      <center>
      <table style="margin-left: 0px; width: 298px;" border="0" cols="1" width="30%">

        <tbody>

          <tr>

            <td style="width: 290px;">Associaci&oacute;
de malabarisme in extremis,</td>

          </tr>

          <tr>

            <td style="width: 290px;">Edifici Omega,
Campus Nord,</td>

          </tr>

          <tr>

            <td style="width: 290px;">08034 Barcelona</td>

          </tr>

        </tbody>
      </table>

      </center>

      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
I les fotos les podeu enviar per <a href="mailto:dani@eel.upc.edu">correu
electr&ograve;nic</a>, o, preferentment, ens les podeu <a href="Vinefes.html">portar en m&agrave;</a>&nbsp;qualsevol
dimecres.</p>

FINAL

$comentari.=<<"FINAL";
	<p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Fins ara hem rebut postals des d'aquests llocs (les podeu veure
clicant-les directament, o per
ordre cronol&ograve;gic, comen&ccedil;ant per la
<a href="$html_primera">primera</a>,
i navegant endavant des de cada postal a la seg&uuml;ent):</p>

FINAL
	} elsif ($idioma eq 'es') {
$comentari=<<'FINAL';
      <p style="margin-left: 40px;"><br>

&nbsp;&nbsp;&nbsp;
ste es el lbum de postales de la asociacin.
Coleccionamos postales de cualquier lugar siempre que vayan acompaadas de una foto del mismo sitio con gente haciendo malabarismo.
Por eso a lo largo de los aos los socios nos han ido enviando postales y fotos que ahora compartimos aqu, en el espacio web.
Si quieres enviarnos una postal acompaada de una foto, ser un placer colgarla en estas pginas. Y adems te convertirs, si an no lo eres, en socio de la asociacin. Para siempre. Y gratis </p>

      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Hay que enviar las postales a esta direccin: </p>

      <center>
      <table style="margin-left: 0px; width: 298px;" border="0" cols="1" width="30%">
        <tbody>
          <tr>
            <td style="width: 290px;">Asociacin de malabarismo in extremis,</td>
          </tr>
          <tr>
            <td style="width: 290px;">Edificio Omega,
Campus Nord,</td>
          </tr>
          <tr>
            <td style="width: 290px;">08034 Barcelona</td>
          </tr>
        </tbody>
      </table>
      </center>

      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Y las fotos las podis enviar por <a href="mailto:dani@eel.upc.edu">correo electrnico</a>, o, preferentemente, nos las podis <a href="Vinefes.es.html">traer en mano</a> cualquier mircoles.</p>

FINAL

$comentari.=<<"FINAL";
      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Hasta ahora hemos recibido postales de los siguientes sitios (las podis ver haciendo clic directamente, o por orden cronolgico, empezando por la
<a href="$html_primera">primera</a>,
y navegando hacia delante desde cada postal a la siguiente):</p>

FINAL

	} elsif ($idioma eq 'en') {
$comentari=<<'FINAL';
      <p style="margin-left: 40px;"><br>

&nbsp;&nbsp;&nbsp;
This is our association postcards album. We collect postacards from all
the world in case they come with a photo from the same place with
people juggling in. So throgh the years, the members have been
sending&nbsp; postcards and photos that we now share here, in the web
site. If you
want to send us a postcard and a photo, it will be our pleasure to put
it here, in this pages. And you will become, if you are not yet, a
member of the association. For ever. And for free. </p>

      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Postcards should be sent to this adress: </p>

      <center>

      <table style="margin-left: 0px; width: 298px;" border="0" cols="1" width="30%">
        <tbody>
          <tr>
            <td style="width: 290px;">Associaci&oacute;
de malabarisme in extremis,</td>
          </tr>
          <tr>
            <td style="width: 290px;">Edifici Omega,
Campus Nord,</td>
          </tr>
          <tr>
            <td style="width: 290px;">08034 Barcelona,
Spain</td>
          </tr>
        </tbody>
      </table>
      </center>

      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
And you can send the fotos via&nbsp;<a href="mailto:dani@eel.upc.edu">e-mail</a>, or, much
better, you can bring them&nbsp;<a href="Vinefes.en.html">by
hand</a> any Wednesday. </p>

FINAL

$comentari.=<<"FINAL";
      <p style="margin-left: 40px;">&nbsp;&nbsp;&nbsp;
Until now we have received postcards from hose places(You can click them to view them, or view in cronological order,
begining with
the <a href="$html_primera">first one</a>,
and surfing ahead from there):</p>
FINAL
	}



my $result=<<"FINAL";


      <div style="text-align: left;">
$comentari

$taula
      </div>

FINAL
	return $result;

	
}

# fi de tot

